*! version 1.0.2 6/16/97 - add S_3
*! version 1.0.1 6/16/97 - fix for long string names
*! version 1.0.0 6/15/97
*
* After logit, probit, mlogit, ologit or oprobit, run catnm as:
*
*   catnm {dep variable}
*
* It will return:
*
*   S_1: a string of names of dependent categories, listing reference
*        category last
*   S_2: number of reference category for logit, probit and mlogit
*      : compares VCE to names of outcome to determine S_2
*   S_3: numbers of dependent categories
*
* To use:         quietly catnm $S_E_depv
*                 local catnm  "$S_1"
*                 local refcat "$S_2"
*                 local catval "$S_3"
*
capture program drop catnm
program define catnm
	version 5.0
	global S_1	/* string of names */
	global S_2  /* reference category */
    tempvar rnum rcount val v
	local if "opt"
	local in "opt"
    local varlist "req min(1)"
    parse "`*'"
    local rname ""
*    local rnum ""
    local lhs "`1'"
    quietly tabulate `1' `if' `in',matrow(`rnum') matcell(`rcount')
    local nrows = rowsof(`rnum')
	local vlab : value label `lhs'
    local irow = 1
    while `irow' <= `nrows' {
        * determine largest category
        local val = `rnum'[`irow',1]
local xval = `val'
    	if "`vlab'" != "" {
            local xname : label `vlab' `val'
    		if "`xname'" == "" {
	    		local xname = `val'
		    }
*di "xname: `xname'"		    
    	}
    	else {
            local xname `val'
    	}
*    	global S_2 `maxcat'
        local rname `rname' `xname'
local rval `rval' `xval'        
*di "rname: `rname'"        
        local irow = `irow' + 1
    }

/* determine information for various regression models */

    * find 0 vs above 0
    if "$S_E_cmd"=="logit" | "$S_E_cmd"=="probit" {
        * for case of 0 vs >0
        if `nrows'~=2 {
            loc i 1
            * find 0
            while `i' <= `nrows' {
                if `rnum'[`i',1]==0 {
                    local nm0 : word `i' of `rname'                
                }
                local i = `i'+1
            }
            local rname `nm0' ~0
            global S_2 1  /* reference category */
        }
    }
    * determine reference category and put it in last location 
    if "$S_E_cmd"=="mlogit" {
        mat `v' = get(VCE)
        local mlnm : coleq(`v')  /* all names except refernece name */
        * get unique sets of category names
        local i = 1
        local nrows = rowsof(`v')
        local vcnm ""
        local nmpre 1
        while `i' <= `nrows' {
            local nm : word `i' of `mlnm'
            if "`nm'"!="`nmpre'" {
                local vcnm `vcnm' `nm'
                local nmpre `nm'
            }
        local i = `i' + 1
        }
*        local vcnm = substr("`vcnm'",2,.)

        local i = 1
        local tmpnm ""
        local tmpval ""
        
        while `i' <= `nrows' {
            local nm : word `i' of `rname'
local val : word `i' of `rval'            
            local x = index("`vcnm'","`nm'")
            if `x'==0 { /* not listed in VCE so must be reference category */
                global S_2 `i'
                local refnm `nm'
local refval `val'                
            }
            else {
                local tmpnm `tmpnm' `nm'
local tmpval `tmpval' `val'                
            }
            local i = `i' + 1
        }
        local tmpnm `tmpnm' `refnm'
local tmpval `tmpval' `refval'                        
local rname = "`tmpnm'"
local rval = "`tmpval'"
    }
    global S_1 `rname'
    global S_3 `rval'    
 di "Categories: $S_1"
 di "Ref Cat:    $S_2"
 di "Values:     $S_3" 
end

