*! version 1.1.8 jsl 6/16/97
capture program drop listodds
capture program drop mnlodds

program define listodds
    version 5.0
    tempvar b f fsd zval pct pctsd sdb sd bout btmp

    if ("$S_E_cmd"!="logit" & "$S_E_cmd"!="ologit" & "$S_E_cmd"!="mlogit") {
        di
        di in r "-listodds- only works after logit, ologit or mlogit."
        exit
        } 
    if "$S_E_cmd"=="logit" | "$S_E_cmd"=="ologit" {
        mat `b' = get(_b)
        local varlist : colnames(`b')
        parse "`varlist'", parse (" ")
    }
    else if "$S_E_cmd"=="mlogit" {
        mnlodds
        exit
    }

    di
    di in g "Factor Changes and Percentage Changes in the Odds"
    di in g "   Procedure: " in y " $S_E_cmd"
    di in g "LHS variable: " in y " $S_E_depv"

* determine # of categories if ordered regression model
    if "$S_E_cmd"=="ologit" {
        local ncats 1
        capture local j=_b[_cut`ncats']
        while _rc==0 {
            local ncats=`ncats'+1
            capture local j=_b[_cut`ncats']
        }
        local nvars = colsof(`b') - `ncats' + 1
    }

    if "$S_E_cmd"=="logit" {
        local nvars = colsof(`b') - 1
    }

    getrhs
    local rhsnam "$S_1"

* get std dev of betas
    mat `sdb' = get(VCE)
    mat `sdb' = vecdiag(`sdb')
* get sd of x's
    getdesc
    mat `sd' = S_2[1,2...] /* trim off lhs variable */

* compute odds coefficients
    mat `b' = `b'[1,1..`nvars'] /* trim off _con */
    if "$S_E_cmd"=="ologit" {mat `b'=`b'*-1}    
    mat `f'    = `b'
    mat `fsd'  = `b'
    mat `zval' = `b'
    mat `pct'  = `b'
    mat `pctsd'  = `b'
    local i 1
    while `i'<=`nvars' {
        mat `sdb'[1,`i']   = sqrt(`sdb'[1,`i'])
        mat `f'[1,`i']     = exp(`f'[1,`i'])
        mat `pct'[1,`i']   = 100*(`f'[1,`i']-1)
        mat `fsd'[1,`i']   = exp(`fsd'[1,`i']*`sd'[1,`i'])
        mat `pctsd'[1,`i'] = 100*(`fsd'[1,`i']-1)
        mat `zval'[1,`i']  = `zval'[1,`i']/`sdb'[1,`i']
        local i = `i' + 1
    }

* write results
    mat `bout' = `b''
    mat `btmp' = `f''    
    mat `bout' = `bout',`btmp'
    mat `btmp' = `fsd''
    mat `bout' = `bout',`btmp'   
    mat `btmp' = `pct''
    mat `bout' = `bout',`btmp'
    mat `btmp' = `pctsd''
    mat `bout' = `bout',`btmp'
    mat `btmp' = `zval''
    mat `bout' = `bout',`btmp'
    mat `btmp' = `sd''
    mat `bout' = `bout',`btmp'

    mat colnames `bout' = b factor factorSd pct pctSd z StdDevX
    if "$S_E_cmd"=="ologit" {
        mat colnames `bout' =-b factor factorSd pct pctSd z StdDevX
    }

    if "$S_E_cmd"=="logit" {
        quietly catnm $S_E_depv
        local nm1 : word 2 of $S_1
        local nm2 : word 1 of $S_1        
    di in g "     Odds of:  " in y "`nm1'" in g " vs " in y "`nm2'"
    }
    if "$S_E_cmd"=="ologit" {
    di in g "     Odds of:  " in y "<k" in g " vs " in y ">=k"
    }        
    mat list `bout',noheader f(%8.3f)
    end

capture program drop mnlodds
program define mnlodds
    version 5.0
    tempvar b bout v sd sdx st en r2 vi se lr lc o
    tempvar b1 b2 b12 eb ebs pb pbs z    
    quietly catnm $S_E_depv
    local catnm  $S_1 /* names of categories, ref is last name */
    local refcat $S_2 /* number of reference category */
    local refnm : word `refcat' of `catnm'
    di in g "BaseCategory:  " in y "`refnm'"
    mat `b' = get(_b)
    mat `v' = get(VCE)
    local varlist : colnames(`b')
    parse "`varlist'", parse (" ")
    quietly getdesc
    mat `sd' = S_2[1,2...]
    local nvars = colsof(`b') /* includes constant */
    local ncatm1 = rowsof(`b')
    local ncat = `ncatm1' + 1
    local ivar = 1
    while `ivar' < `nvars' {
        local vname: word `ivar' of `varlist'
        di
        di in g "Variable: " in w "`vname'"
        di
        di in g "Contrast" _col(20) /*
        */ "      b       z   P>|z|     exp  expstd       %    %std"
        di in gr _dup(78) "-"        
        scalar `sdx' = `sd'[1,`ivar']
        local i1 1
        while `i1' < `ncat' {
            local i2 1
            while `i2' <= `ncat' {
                if `i1'!=`i2' {
                    local nm1 : word `i1' of `catnm'
                    local nm2 : word `i2' of `catnm'
                    if `i2'==`ncat' { scalar `b2' = 0 }
                    else { scalar `b2' = `b'[`i2',`ivar'] }
                    scalar `b1' = `b'[`i1',`ivar']
                    scalar `b12' = `b1'-`b2'
                    scalar `eb' = exp(`b12')
                    scalar `ebs' = exp(`b12'*`sdx')                
                    scalar `pb' = (`eb'-1)*100
                    scalar `pbs' = (`ebs'-1)*100
                    local l2 = ((`i2'-1)*`nvars')+`ivar'
                    if `i2'==`ncat' {
                        scalar `se' = sqrt(`v'[`l1',`l1'])
                    }    
                    else {
                        local l1 = ((`i1'-1)*`nvars')+`ivar'
                        scalar `se' = sqrt(`v'[`l1',`l1'] + /*
                        */          `v'[`l2',`l2'] - 2*`v'[`l1',`l2'])
                    }                        
                    scalar `se' = 1/`se'
                    scalar `z' = `se'*`b12'
                    di in g "`nm1'" _col(9) "-`nm2'" _col(20) /*
                    */ in y %7.4f `b12' %8.3f `z' %8.2f 2*normprob(-abs(`z')) /*
                    */ %8.3f `eb' %8.3f `ebs' %8.1f `pb' %8.1f  `pbs' 
                }
                local i2 = `i2' + 1 
            } /* i2 */
            local i2 1        
            local i1 = `i1' + 1
        } /* i1 */
        local ivar = `ivar' + 1
    } /* over vars */
end

