capture program drop poissonp
*! version 1.0.1 jsl 6/26/97
* check if in       
program define poissonp
	version 5.0
	if "$S_E_cmd"!="poisson" {
	    error 301
    }
    tempname obs psn preg val mean overn
    local varlist "new max(1)"
    local if "opt noprefix"
    local in "opt"
    local options "Max(integer 9)"
    parse "`*'"
    local ifno "`if'"
    if "`if'"~="" { local if "if `if'" }
    local nprobs = `max'+1  /* number of probs to calculate */
    local root "`varlist'"
    drop `root'
    local root = substr("`root'",1,4)
    local rootp "`root'P"
    local mu "`root'mu"
    quietly { 
        local dv = "$S_E_depv"
        predict double `mu' `if' `in'
        label var `mu' "mu=exp(xb)"
        sum `dv' `if' `in'
        scalar `mean' = _result(3)
    	mat `obs' = J(`nprobs',1,1) 
    	mat `preg' = J(`nprobs',1,1) 
    	mat `val' = J(`nprobs',1,1) 
        replace `mu' = exp(`mu')
        local i = 0
        local maxk = `nprobs'-1
        gen double `rootp'gt = 1 `if' `in'        
        label var `rootp'gt "Pr(k>`maxk')"
        while `i' <= `maxk' {
	        local i1 = `i'+1
	        if "`ifno'"=="" { count if `dv'==`i' `in' }
	        else { count if `dv'==`i'&`ifno' `in' }
	        mat `obs'[`i1',1] = _result(1) /* observed prob */
            gen double `rootp'`i' = exp(-`mu')*(`mu'^`i') /*
                              */   /round(exp(lnfact(`i')),1) `if' `in'
            label var `rootp'`i' "Pr(k=`i')"                
            replace `rootp'gt = `rootp'gt - `rootp'`i' `if' `in'
            sum `rootp'`i', meanonly
  	        mat `preg'[`i1',1] = _result(3) /* mean of poisson reg prediction */
    	    mat `val'[`i1',1] = `i' /* value of count */
            local i=`i'+1
   	    }
    }
  	scalar `overn' = 1/_result(1)
    mat `obs' = `obs'*`overn'
   	svmat `obs',name("`root'obs")
    rename `root'obs1 `root'obs
    label var `root'obs "Observed Probability"
   	svmat `preg',name("`root'reg")
    rename `root'reg1 `root'reg
    label var `root'reg "Predicted Poisson Regression"
   	svmat `val',name("`root'val")
   	rename `root'val1 `root'val
    label var `root'val "Value of the Count"
end

