*! version 1.2.0 jsl 6/16/97
capture program drop predval

* do: add tobit

program define predval
    version 4.0
    tempvar b xmn xmin xmax x predval predpr ncol colnm i tmp xblbl xbscal

    if ("$S_E_cmd"!="poisson" & "$S_E_cmd"!="regress" /*
    */ & "$S_E_cmd"!="logit" & "$S_E_cmd"!="probit" /*
    */ & "$S_E_cmd"!="ologit" & "$S_E_cmd"!="oprobit" /*
    */ & "$S_E_cmd"!="nbreg" & "$S_E_cmd"!="mlogit" /*
    */ ) {
        di
        di in r "-predval- does not work for the last type of model estimated."
        exit
    } 

    local if "opt"
    local in "opt"
    local varlist "none"
    parse "`*'", parse(" ,")
    local atopt = "`1'"
    local l = length("`1'")+2
    local ifin = substr("`*'",`l',.)
    parse "`ifin'" /* parse the if & in conditions */

* get names of outcome categores
    if ( "$S_E_cmd"=="logit"  | "$S_E_cmd"=="probit" /*
    */ | "$S_E_cmd"=="ologit" | "$S_E_cmd"=="oprobit" /*
    */ | "$S_E_cmd"=="mlogit" /*
    */ ) {
        quietly catnm $S_E_depv `if' `in'
        local refcat $S_2
        local catnm  $S_1
    }        

* get names of independent variables
    mat `b' = get(_b)
    if "$S_E_cmd"=="nbreg" {
        local nb = colsof(`b') - 1 /* -1 for alpha */        
        mat `b' = `b'[1,1..`nb']
    }
    getrhs
    local varlist "$S_1"

* get desc stats for variables
    quietly getdesc `if' `in' /* one of jsl's ado files */
    mat `xmn' = S_1[1,2...]
    local nvars = colsof(`xmn')
    mat `xmin' = S_3[1,2...]
    mat `xmax' = S_4[1,2...]

    if "`atopt'"=="" { local atopt "mean" }

* assign value of x to check
    if "`atopt'"=="mean" {
        mat `x' = `xmn'
    }
    else if "`atopt'"=="min" {
        mat `x' = `xmin'
    }
    else if "`atopt'"=="max" {
        mat `x' = `xmax'
    }
    else if "`atopt'"=="upper" {
        if "$S_E_cmd"=="probit" | "$S_E_cmd"=="logit" /*
        */    | "$S_E_cmd"=="regress" | "$S_E_cmd"=="poisson" /*
        */    | "$S_E_cmd"=="nbreg"  /*
        */    | "$S_E_cmd"=="oprobit" | "$S_E_cmd"=="ologit"  {
            mat `x' = `xmax'
            local i = 1
            while `i'<=`nvars' {
                if `b'[1,`i']<0 {
                    mat `x'[1,`i'] = `xmin'[1,`i']
                }
            local i=`i'+1
            }
        }
    }

    else if "`atopt'"=="lower" {
        if "$S_E_cmd"=="probit" | "$S_E_cmd"=="logit" /*
        */  | "$S_E_cmd"=="regress" | "$S_E_cmd"=="poisson" /*
        */  | "$S_E_cmd"=="oprobit" | "$S_E_cmd"=="ologit"  {
            mat `x' = `xmin'
            local i = 1
            while `i'<=`nvars' {
                if `b'[1,`i']<0 {
                    mat `x'[1,`i'] = `xmax'[1,`i']
                }
            local i=`i'+1
            }
        }
        else {
            di in r "Option" in y " lower " in r "does not work for last model estimated."
            exit
        }
    }
    else if "`atopt'"=="base" {

        if "`if'"!=""|"`in'"!="" {
            di
            di in w "predval base" in r " does not work with if or in conditions."
            exit
        }
        capture local nbase = colsof(jsl_base)
        local nbase = `nbase' - 1
        if `nbase'~=`nvars' {
            di in r "The base has the wrong number of values."
            exit
        }

* assume names of variables in the model
        mat `x' = jsl_base[1,2...]
        mat `tmp' = J(1,1,1)
        mat `x' = `x',`tmp'
        mat colnames `x' = `varlist'        
        mat `x' = `x'[1,1..`nbase']
    }
    else {
        di in r "You must enter: predval [mean min max upper lower base]"
        exit
    }
* get predictions
    mat S_1 = `x'
    p_val
    mat `predval' = S_1
    mat `predpr' = S_2
   
* output header
    di " "
    di in g "Predictions for " in y "$S_E_cmd" in g /*
    */ " with LHS variable " in y "$S_E_depv"

* output predicted values
    if "$S_E_cmd"=="poisson" | "$S_E_cmd"=="nbreg" {
        scalar `tmp' = `predval'[1,1]
        di
        di in g "exp(xb)  " in y `tmp'
    }
    if "$S_E_cmd"=="regress" {
        scalar `tmp' = `predval'[1,1]
        di
        di in g "xb  " in y `tmp'
    }    
    if "$S_E_cmd"=="mlogit" {
        mat `predval' = `predval''
    }

* predicted probabilities
    mat rownames `predpr' = Prob
    if "$S_E_cmd"=="poisson" {
        mat colnames `predpr' = =0 =1 =2 =3 =4 =5 =6 =7 =8 =9
    }
    if "$S_E_cmd"=="logit" | "$S_E_cmd"=="probit" {
        mat colnames `predpr' = `catnm'
    }
    if "$S_E_cmd"=="oprobit" | "$S_E_cmd"=="ologit" {
        mat colnames `predpr' = `catnm'
    }
    if "$S_E_cmd"=="mlogit" {
        mat colnames `predpr' = `catnm'
    }

    if "$S_E_cmd"~="regress" {
        mat list `predpr',noheader f(%8.3g)
    }

* values of x's
    local atopt = "X=`atopt'"
    mat rownames `x' = `atopt'
    mat list `x',noheader f(%8.3g)

end

