capture program drop tobase
*!version 1.1.7 6/17/97 - multiple var value
*!version 1.1.6 6/17/97 - add if and in
*!version 1.1.5 6/15/97 - clean listing, trap if bad variable name
* version 1.1.4 9/10/96

program define tobase
    version 4.0
    tempvar tmp input
    local input = "`*'"
    parse "`*'", parse(" ")
    local opt = "`1'"

* get if and in for mean min max 
    if "`opt'"=="mean"|"`opt'"=="min"|"`opt'"=="max" {
        if "`2'"!="" {
            macro shift
        	local if "opt"
	        local in "opt"
        	parse "`*'"
        }
    }        

* just list current base
    if "`opt'"=="" {
        capture mat list jsl_base
        if _rc==0 {
            matrix rown jsl_base = Base=
            mat list jsl_base,noheader
        }
        else {
            di " "
            di "No base values have been set."
        }
        exit
    }

    
    

* get desc stats for variables
    capture local varlist : colnames(jsl_base)
    if "`opt'"=="mean"|"`opt'"=="min"|"`opt'"=="max" {
        quietly getdesc `if' `in'
        if "`opt'"=="mean" {
            mat jsl_base = S_1
        }
        else if "`opt'"=="min" {
            mat jsl_base = S_3
        }
        else if "`opt'"=="max" {
            mat jsl_base = S_4
        }
        exit
    }

* modify specified columns    
    if "`1'"=="c" {
        local ncols = colsof(jsl_base)
        if "`3'"=="" {
            di in red "Syntax is tobase # location value."
        }
        confirm number `3'
        if "`2'"<="`ncols'" {
            mat jsl_base[1,`2'] = `3'
        }
        else {
            di in red "Location is too large."
        }
        exit
    }


* if it hasn't made change yet, create new base
    capture confirm number `1'
    if _rc==0 {
        parse "`input'", parse(" ")
        mat jsl_base = J(1,1,1)
        mat `tmp' = jsl_base
        mat jsl_base[1,1] = `1'
        macro shift
        while "`1'"~="" {
            confirm number `1'                            
            mat `tmp'[1,1] = `1'
            mat jsl_base = jsl_base,`tmp'
            macro shift
    
        }
        exit
    }

* change specified variable    
    parse "`input'", parse(" ")
    matrix `tmp' = jsl_base
    while "`1'"~="" {
        if "`2'"=="" {
            di
            di in r "Variables and values do not match. No changes made."
            matrix jsl_base = `tmp'
            exit
        }
        confirm number `2'        
        local var = "`1'"
        local val = `2'
        local i = 1
        local nvars = colsof(jsl_base)
        local found "no"                
        while `i' <= `nvars' {
            local nmtoget : word `i' of `varlist'
            if "`nmtoget'"=="`var'" {
                local found "yes"
                mat jsl_base[1,`i'] = `val'
            }
            local i = `i' + 1
        }
        if "`found'"=="no" {
            di
            di in red "Variable `var' not found. No changes made."
            matrix jsl_base = `tmp'
            exit                
        }    
    macro shift
    macro shift
    }


end
